﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.Diagnostics;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        int LedData = 0;

        bool TX = false;
        bool KontinuierlicheAbfrageAktiv = false;

        int TxCounter = 0;

        public Form1()
        {
            InitializeComponent();
            if (Properties.Settings.Default.SerialPortName !="") serialPort1.PortName = Properties.Settings.Default.SerialPortName;
            serialPort1.BaudRate = Properties.Settings.Default.Baudrate;
            if (serialPort1.BaudRate == 4800) toolStripMenuItem4800.Checked = false;
            if (serialPort1.BaudRate == 9600) toolStripMenuItem9600.Checked = true;
            if (serialPort1.BaudRate == 19200) toolStripMenuItem19200.Checked = true;
            if (serialPort1.BaudRate == 57600) toolStripMenuItem57600.Checked = true;
            if (serialPort1.BaudRate == 115200) toolStripMenuItem115200.Checked = true;
            toolStripStatusLabelUART.Text = serialPort1.PortName + " Baudrate: " + serialPort1.BaudRate.ToString();
            string[] ports = SerialPort.GetPortNames();
            Array.Sort(ports);
            foreach (string port in ports)
            {
                uARTToolStripMenuItem.DropDownItems.Add(port);
            }
            timer1.Interval = int.Parse(numericUpDownIntervall.Value.ToString())/2;
        }
        
 
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (serialPort1.IsOpen==true) serialPort1.Close();
            Properties.Settings.Default.Baudrate = serialPort1.BaudRate;
            Properties.Settings.Default.SerialPortName = serialPort1.PortName;
            Properties.Settings.Default.Save();
        }

        private void buttonTransfer_Click(object sender, EventArgs e)
        {
            string TXString = "";
            LedData = 0;
            if (checkBoxTA4.Checked) LedData += 1;
            if (checkBoxTB4.Checked) LedData += 2;
            if (checkBoxTC4.Checked) LedData += 4;

            if (checkBoxTA5.Checked) LedData += 16;
            if (checkBoxTB5.Checked) LedData += 32;
            if (checkBoxTC5.Checked) LedData += 64;

            TXString = "@Q" + LedData.ToString("X2");
            LedData = 0;
            if (checkBoxTA1.Checked) LedData += 1;
            if (checkBoxTB1.Checked) LedData += 2;
            if (checkBoxTC1.Checked) LedData += 4;
            if (checkBoxTD1.Checked) LedData += 8;

            if (checkBoxTA2.Checked) LedData += 16;
            if (checkBoxTB2.Checked) LedData += 32;
            if (checkBoxTC2.Checked) LedData += 64;
            if (checkBoxTD2.Checked) LedData += 128;

            if (checkBoxTA3.Checked) LedData += 256;
            if (checkBoxTB3.Checked) LedData += 512;
            if (checkBoxTC3.Checked) LedData += 1024;
            if (checkBoxTD3.Checked) LedData += 2048;

            TXString = TXString + LedData.ToString("X4");
            textBoxTXData.Text = TXString;
            textBoxTxCRC.Text = CRC16(TXString).ToString("X4");
            TXString = TXString + textBoxTxCRC.Text;
            try
            {
                textBoxTXData.BackColor = Color.Yellow;
                if (serialPort1.IsOpen == false) serialPort1.Open();
                serialPort1.DiscardInBuffer();
                serialPort1.WriteLine(TXString + "\r");
                textBoxTXData.BackColor = SystemColors.Window;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            System.Threading.Thread.Sleep(200);
            //textBoxRXData.Text = serialPort1.ReadExisting();
            try
            {
                AnalyseRXString(serialPort1.ReadExisting());
            }
            catch
            {
            }
        }

        

        private UInt16 CRC16(String ASCII)
        {
            UInt16 crc_int = 0xFFFF;          // initial value
            UInt16 polynomial = 0x1021;   // 0001 0000 0010 0001  (0, 5, 12) 

            char[] Character = ASCII.ToCharArray();
            for (int j = 0; j < ASCII.Length; j++)
            {
                for (int i = 0; i < 8; i++)
                {
                    bool bit = ((Character[j] >> (7 - i) & 1) == 1);
                    bool c15 = ((crc_int >> 15 & 1) == 1);
                    crc_int <<= 1;
                    if (c15 ^ bit) crc_int ^= polynomial;
                }
            }
            crc_int &= 0xffff;
            return crc_int;
        }

        

        private void checkBoxLoopBack_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBoxLoopBack.Checked)
            {
                buttonAlleLEDsAn.Enabled = false;
                timer1.Enabled = true;
                TX = true;
            }
            else
            {
                timer1.Enabled = false;
                buttonAlleLEDsAn.Enabled = true;
            }
        }
        
        bool IsBitSet(byte b, int pos)
        {
            return (b & (1 << pos)) != 0;
        }

        void AnalyseRXString(string RxString)
        {
            labelDebug.Text = "";
            try
            {
                labelDebug.Text = RxString.Substring(0, RxString.Length - 1) + " L= " + RxString.Length.ToString(); ;

                if (RxString.Length == 17) // Antworttelegrammlänge OK
                {
                    textBoxRXData.Text = RxString.Substring(0, 12);
                    textBoxRxCRC.Text = RxString.Substring(12, 4);
                    // labelDebug.Text = RxString.Length.ToString();

                    byte[] RXData = new byte[12];
                    //for (int i = 0; i < 11; i++) RXData[i] = 0;
                    //for (int i = 0; i < 11; i++) RXData[i] = Convert.ToByte(RxString[i + 2]);
                    for (int i = 0; i < 11; i++) RXData[i] = Convert.ToByte(RxString.Substring(i + 2, 1), 16);

                    if (IsBitSet(RXData[5], 0)) checkBoxTA1.BackColor = Color.Green; else checkBoxTA1.BackColor = SystemColors.Control;
                    if (IsBitSet(RXData[5], 1)) checkBoxTB1.BackColor = Color.Green; else checkBoxTB1.BackColor = SystemColors.Control;
                    if (IsBitSet(RXData[5], 2)) checkBoxTC1.BackColor = Color.Green; else checkBoxTC1.BackColor = SystemColors.Control;
                    if (IsBitSet(RXData[5], 3)) checkBoxTD1.BackColor = Color.Green; else checkBoxTD1.BackColor = SystemColors.Control;
                    
                    if (IsBitSet(RXData[4], 0)) checkBoxTA2.BackColor = Color.Green; else checkBoxTA2.BackColor = SystemColors.Control;
                    if (IsBitSet(RXData[4], 1)) checkBoxTB2.BackColor = Color.Green; else checkBoxTB2.BackColor = SystemColors.Control;
                    if (IsBitSet(RXData[4], 2)) checkBoxTC2.BackColor = Color.Green; else checkBoxTC2.BackColor = SystemColors.Control;
                    if (IsBitSet(RXData[4], 3)) checkBoxTD2.BackColor = Color.Green; else checkBoxTD2.BackColor = SystemColors.Control;

                    if (IsBitSet(RXData[7], 0)) checkBoxTA3.BackColor = Color.Green; else checkBoxTA3.BackColor = SystemColors.Control;
                    if (IsBitSet(RXData[7], 1)) checkBoxTB3.BackColor = Color.Green; else checkBoxTB3.BackColor = SystemColors.Control;
                    if (IsBitSet(RXData[7], 2)) checkBoxTC3.BackColor = Color.Green; else checkBoxTC3.BackColor = SystemColors.Control;
                    if (IsBitSet(RXData[7], 3)) checkBoxTD3.BackColor = Color.Green; else checkBoxTD3.BackColor = SystemColors.Control;

                    if (IsBitSet(RXData[9], 0)) checkBoxTA4.BackColor = Color.Green; else checkBoxTA4.BackColor = SystemColors.Control;
                    if (IsBitSet(RXData[9], 1)) checkBoxTB4.BackColor = Color.Green; else checkBoxTB4.BackColor = SystemColors.Control;
                    if (IsBitSet(RXData[9], 2)) checkBoxTC4.BackColor = Color.Green; else checkBoxTC4.BackColor = SystemColors.Control;
                    if (IsBitSet(RXData[9], 3)) labelTsOben.BackColor = Color.Green; else labelTsOben.BackColor = SystemColors.Control;

                    if (IsBitSet(RXData[8], 0)) checkBoxTA5.BackColor = Color.Green; else checkBoxTA5.BackColor = SystemColors.Control;
                    if (IsBitSet(RXData[8], 1)) checkBoxTB5.BackColor = Color.Green; else checkBoxTB5.BackColor = SystemColors.Control;
                    if (IsBitSet(RXData[8], 2)) checkBoxTC5.BackColor = Color.Green; else checkBoxTC5.BackColor = SystemColors.Control;
                    if (IsBitSet(RXData[8], 3)) labelTsUnten.BackColor = Color.Green; else labelTsUnten.BackColor = SystemColors.Control;
                    int PositionHandrad = Convert.ToInt32(RxString.Substring(2, 4), 16);
                    buttonHRPosition.Text = PositionHandrad.ToString("X4");
                    textBoxRXData.BackColor = Color.LightGreen;
                }
                else
                {
                    textBoxRXData.Text = "No Data";
                    textBoxRxCRC.Text = "";
                    textBoxRXData.BackColor = Color.Red;
                }
            }
            catch
            {
                textBoxRXData.Text = "No Data";
                textBoxRxCRC.Text = "";
                textBoxRXData.BackColor = Color.Red;
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if (TX == true)
            {
                string TXString = "";
                if (checkBoxLCDUpdate.Checked) TxCounter++;
                else TxCounter = 1;
                if (TxCounter == 1)
                {
                    if (checkBoxLoopBack.Checked)
                    {
                        LedData = 0;
                        if (checkBoxTA4.BackColor == Color.Green) LedData += 1;
                        if (checkBoxTB4.BackColor == Color.Green) LedData += 2;
                        if (checkBoxTC4.BackColor == Color.Green) LedData += 4;

                        if (checkBoxTA5.BackColor == Color.Green) LedData += 16;
                        if (checkBoxTB5.BackColor == Color.Green) LedData += 32;
                        if (checkBoxTC5.BackColor == Color.Green) LedData += 64;
                        TXString = "@Q" + LedData.ToString("X2");
                        LedData = 0;
                        if (checkBoxTA1.BackColor == Color.Green) LedData += 1;
                        if (checkBoxTB1.BackColor == Color.Green) LedData += 2;
                        if (checkBoxTC1.BackColor == Color.Green) LedData += 4;
                        if (checkBoxTD1.BackColor == Color.Green) LedData += 8;

                        if (checkBoxTA2.BackColor == Color.Green) LedData += 16;
                        if (checkBoxTB2.BackColor == Color.Green) LedData += 32;
                        if (checkBoxTC2.BackColor == Color.Green) LedData += 64;
                        if (checkBoxTD2.BackColor == Color.Green) LedData += 128;

                        if (checkBoxTA3.BackColor == Color.Green) LedData += 256;
                        if (checkBoxTB3.BackColor == Color.Green) LedData += 512;
                        if (checkBoxTC3.BackColor == Color.Green) LedData += 1024;
                        if (checkBoxTD3.BackColor == Color.Green) LedData += 2048;
                    }
                    else
                    {
                        LedData = 0;
                        if (checkBoxTA4.Checked) LedData += 1;
                        if (checkBoxTB4.Checked) LedData += 2;
                        if (checkBoxTC4.Checked) LedData += 4;

                        if (checkBoxTA5.Checked) LedData += 16;
                        if (checkBoxTB5.Checked) LedData += 32;
                        if (checkBoxTC5.Checked) LedData += 64;

                        TXString = "@Q" + LedData.ToString("X2");
                        LedData = 0;
                        if (checkBoxTA1.Checked) LedData += 1;
                        if (checkBoxTB1.Checked) LedData += 2;
                        if (checkBoxTC1.Checked) LedData += 4;
                        if (checkBoxTD1.Checked) LedData += 8;

                        if (checkBoxTA2.Checked) LedData += 16;
                        if (checkBoxTB2.Checked) LedData += 32;
                        if (checkBoxTC2.Checked) LedData += 64;
                        if (checkBoxTD2.Checked) LedData += 128;

                        if (checkBoxTA3.Checked) LedData += 256;
                        if (checkBoxTB3.Checked) LedData += 512;
                        if (checkBoxTC3.Checked) LedData += 1024;
                        if (checkBoxTD3.Checked) LedData += 2048;
                    }
                    TXString = TXString + LedData.ToString("X4");
                }

                if (TxCounter == 2) // Textzeile 1
                {
                    TXString = "@M" + maskedTextBox1.Text.PadRight(20, ' ');
                }
                if (TxCounter == 3) // Textzeile 2
                {
                    TXString = "@N" + maskedTextBox2.Text.PadRight(20, ' ');
                } 
                if (TxCounter == 4) // Textzeile 3
                {
                    TXString = "@O" + maskedTextBox3.Text.PadRight(20, ' ');
                }
                if (TxCounter == 5) // Textzeile 4
                {
                    TXString = "@P" + maskedTextBox4.Text.PadRight(20, ' ');
                }
                textBoxTXData.Text = TXString;
                textBoxTxCRC.Text = CRC16(TXString).ToString("X4");
                TXString = TXString + textBoxTxCRC.Text;
                try
                {
                    textBoxTXData.BackColor = Color.Yellow;
                    textBoxRXData.BackColor = Color.White;
                    if (serialPort1.IsOpen == false)
                    {
                        serialPort1.Open();
                        serialPort1.DiscardOutBuffer();
                        serialPort1.DiscardInBuffer();
                    }
                    serialPort1.WriteLine(TXString + "\r");
                }
                catch (Exception ex)
                {
                    KontinuierlicheAbfrageAktiv = false;
                    buttonIoXfer.Text = "Kontinuierliche Abfrage\n\rstarten";
                    serialPort1.Close();
                    timer1.Enabled = false;

                    MessageBox.Show(ex.Message);
                }


                TX = false;
                if (TxCounter > 4) TxCounter = 0;

            }
            else
            {
                textBoxTXData.BackColor = SystemColors.Window;
                try
                {
                    if (serialPort1.IsOpen == false) serialPort1.Open();
                    AnalyseRXString(serialPort1.ReadExisting());

                }
                catch (Exception ex)
                {
                    textBoxRXData.BackColor = Color.Red;
                    textBoxRXData.Text = "";
                    //MessageBox.Show(ex.Message);
                }
                TX = true;
                textBoxTXData.BackColor = Color.White;
            }
        }


       

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            timer1.Interval = int.Parse(numericUpDownIntervall.Value.ToString())/2;
        }

        private void toolStripMenuItem4800_Click(object sender, EventArgs e)
        {
            toolStripMenuItem4800.Checked = true;
            toolStripMenuItem9600.Checked = false;
            toolStripMenuItem19200.Checked = false;
            toolStripMenuItem57600.Checked = false;
            toolStripMenuItem115200.Checked = false;
            serialPort1.BaudRate = 4800;
            Properties.Settings.Default.Baudrate = serialPort1.BaudRate;

            toolStripStatusLabelUART.Text = serialPort1.PortName + " Baudrate:" + serialPort1.BaudRate.ToString();
        }


        private void toolStripMenuItem9600_Click(object sender, EventArgs e)
        {
            toolStripMenuItem4800.Checked = false;
            toolStripMenuItem9600.Checked = true;
            toolStripMenuItem19200.Checked = false;
            toolStripMenuItem57600.Checked = false;
            toolStripMenuItem115200.Checked = false;
            serialPort1.BaudRate = 9600;
            Properties.Settings.Default.Baudrate = serialPort1.BaudRate;

            toolStripStatusLabelUART.Text = serialPort1.PortName + " Baudrate:" + serialPort1.BaudRate.ToString();
        }

        private void toolStripMenuItem19200_Click(object sender, EventArgs e)
        {
            toolStripMenuItem4800.Checked = false;
            toolStripMenuItem9600.Checked = false;
            toolStripMenuItem19200.Checked = true;
            toolStripMenuItem57600.Checked = false;
            toolStripMenuItem115200.Checked = false;
            serialPort1.BaudRate = 19200;
            Properties.Settings.Default.Baudrate = serialPort1.BaudRate;

            toolStripStatusLabelUART.Text = serialPort1.PortName + " Baudrate:" + serialPort1.BaudRate.ToString();
        }

        private void toolStripMenuItem57600_Click(object sender, EventArgs e)
        {
            toolStripMenuItem4800.Checked = false;
            toolStripMenuItem9600.Checked = false;
            toolStripMenuItem19200.Checked = false;
            toolStripMenuItem57600.Checked = true;
            toolStripMenuItem115200.Checked = false;
            serialPort1.BaudRate = 57600;
            Properties.Settings.Default.Baudrate = serialPort1.BaudRate;

            toolStripStatusLabelUART.Text = serialPort1.PortName + " Baudrate:" + serialPort1.BaudRate.ToString();
        }

        private void toolStripMenuItem115200_Click(object sender, EventArgs e)
        {
            toolStripMenuItem4800.Checked = false;
            toolStripMenuItem9600.Checked = false;
            toolStripMenuItem19200.Checked = false;
            toolStripMenuItem57600.Checked = false;
            toolStripMenuItem115200.Checked = true;
            serialPort1.BaudRate = 115200;
            Properties.Settings.Default.Baudrate = serialPort1.BaudRate;

            toolStripStatusLabelUART.Text = serialPort1.PortName + " Baudrate:" + serialPort1.BaudRate.ToString();
        }

        private void einstellungenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            while (uARTToolStripMenuItem.DropDownItems.Count > 0) uARTToolStripMenuItem.DropDownItems.RemoveAt(0);

            string[] ports = SerialPort.GetPortNames();
            Array.Sort(ports);
            foreach (string port in ports)
            {
                //uARTToolStripMenuItem.DropDownItems.Add(port);

                ToolStripMenuItem it = (ToolStripMenuItem)uARTToolStripMenuItem.DropDownItems.Add(port);
                it.Name = port;  // This was missing
                //((ToolStripMenuItem)menuItem).Checked = true;
                if (port == serialPort1.PortName) it.Checked = true;
            }

        }

        private void uARTToolStripMenuItem_DropDownItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {
            
            serialPort1.Close();
            for (int i = 0; i < uARTToolStripMenuItem.DropDownItems.Count; i++)
            {
                if (uARTToolStripMenuItem.DropDownItems[i].Selected == true)
                {
                    serialPort1.PortName = uARTToolStripMenuItem.DropDownItems[i].Text;
                    //uARTToolStripMenuItem.Checked = true;
                    //MessageBox.Show(uARTToolStripMenuItem.DropDownItems.ToString());
                }
            }
            toolStripStatusLabelUART.Text = serialPort1.PortName + " Baudrate:" + serialPort1.BaudRate.ToString();

        }

        private void buttonAlleLEDsAn_Click(object sender, EventArgs e)
        {
            string TXString = "@Q";
            checkBoxTA1.Checked = true;
            checkBoxTB1.Checked = true;
            checkBoxTC1.Checked = true;
            checkBoxTD1.Checked = true;
            checkBoxTA2.Checked = true;
            checkBoxTB2.Checked = true;
            checkBoxTC2.Checked = true;
            checkBoxTD2.Checked = true;
            checkBoxTA3.Checked = true;
            checkBoxTB3.Checked = true;
            checkBoxTC3.Checked = true;
            checkBoxTD3.Checked = true;
            checkBoxTA4.Checked = true;
            checkBoxTB4.Checked = true;
            checkBoxTC4.Checked = true;
            checkBoxTA5.Checked = true;
            checkBoxTB5.Checked = true;
            checkBoxTC5.Checked = true;
            LedData = 0xffff;

            TXString = TXString + "77" + LedData.ToString("X4") ;
            textBoxTXData.Text = TXString;
            textBoxTxCRC.Text = CRC16(TXString).ToString("X4");
            TXString = TXString + textBoxTxCRC.Text;
            try
            {
                if (serialPort1.IsOpen == false) serialPort1.Open();
                serialPort1.WriteLine(TXString + "\r");
                System.Threading.Thread.Sleep(200);
                AnalyseRXString(serialPort1.ReadExisting());
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            

        }

        private void buttonAlleLEDsAus_Click(object sender, EventArgs e)
        {
            string TXString = "@Q";
            LedData = 0;
            checkBoxTA1.Checked = false;
            checkBoxTB1.Checked = false;
            checkBoxTC1.Checked = false;
            checkBoxTD1.Checked = false;
            checkBoxTA2.Checked = false;
            checkBoxTB2.Checked = false;
            checkBoxTC2.Checked = false;
            checkBoxTD2.Checked = false;
            checkBoxTA3.Checked = false;
            checkBoxTB3.Checked = false;
            checkBoxTC3.Checked = false;
            checkBoxTD3.Checked = false;
            checkBoxTA4.Checked = false;
            checkBoxTB4.Checked = false;
            checkBoxTC4.Checked = false;
            
            checkBoxTA5.Checked = false;
            checkBoxTB5.Checked = false;
            checkBoxTC5.Checked = false;
            
            TXString = TXString + LedData.ToString("X4") + "00";
            textBoxTXData.Text = TXString;
            textBoxTxCRC.Text = CRC16(TXString).ToString("X4");
            TXString = TXString + textBoxTxCRC.Text;
            try
            {
                if (serialPort1.IsOpen == false) serialPort1.Open();
                serialPort1.WriteLine(TXString + "\r");
                System.Threading.Thread.Sleep(200);
                AnalyseRXString(serialPort1.ReadExisting());
                serialPort1.Close();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void buttonIoXfer_Click(object sender, EventArgs e)
        {
            if (KontinuierlicheAbfrageAktiv == true)
            {
                KontinuierlicheAbfrageAktiv = false;
                buttonIoXfer.Text = "Kontinuierliche Abfrage\n\rstarten";
                serialPort1.Close();
                timer1.Enabled = false;
//                checkBoxLoopBack.Enabled = false;
//                checkBoxLoopBack.Checked = false;
                numericUpDownIntervall.Enabled = false;
                groupBox1.Enabled = true;
                
            }
            else
            {
                checkBoxLoopBack.Enabled = true;
                numericUpDownIntervall.Enabled = true;
                groupBox1.Enabled = false;
                try
                {
                    if (serialPort1.IsOpen == false)
                    {
                        serialPort1.Open();
                        serialPort1.DiscardInBuffer();
                        serialPort1.DiscardOutBuffer();
                    }
                    KontinuierlicheAbfrageAktiv = true;
                    buttonIoXfer.Text = "Kontinuierliche Abfrage\n\rbeenden";
                    timer1.Enabled = true;
                }
                catch (Exception ex)
                {
                    serialPort1.Close();
                    MessageBox.Show(ex.Message);
                }
            }
        }

        private void buttonTransferText1_Click(object sender, EventArgs e)
        {

            string TXString = "@M" + maskedTextBox1.Text.PadRight(20, ' ');
            
            textBoxTXData.Text = TXString;
            textBoxTxCRC.Text = CRC16(TXString).ToString("X4");
            
            TXString = TXString + textBoxTxCRC.Text;
            try
            {
                if (serialPort1.IsOpen == false) serialPort1.Open();
                serialPort1.WriteLine(TXString + "\r");
                System.Threading.Thread.Sleep(200);
                AnalyseRXString(serialPort1.ReadExisting());
                serialPort1.Close();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void buttonTransferText2_Click(object sender, EventArgs e)
        {
            string TXString = "@N" + maskedTextBox2.Text.PadRight(20, ' ');
            textBoxTXData.Text = TXString;
            textBoxTxCRC.Text = CRC16(TXString).ToString("X4");
            TXString = TXString + textBoxTxCRC.Text;
            try
            {
                if (serialPort1.IsOpen == false) serialPort1.Open();
                serialPort1.WriteLine(TXString + "\r");
                System.Threading.Thread.Sleep(200);
                AnalyseRXString(serialPort1.ReadExisting());
                serialPort1.Close();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void buttonTransferText3_Click(object sender, EventArgs e)
        {
            string TXString = "@O" + maskedTextBox3.Text.PadRight(20, ' ');
            textBoxTXData.Text = TXString;
            textBoxTxCRC.Text = CRC16(TXString).ToString("X4");
            TXString = TXString + textBoxTxCRC.Text;
            try
            {
                if (serialPort1.IsOpen == false) serialPort1.Open();
                serialPort1.WriteLine(TXString + "\r");
                System.Threading.Thread.Sleep(200);
                AnalyseRXString(serialPort1.ReadExisting());
                serialPort1.Close();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

        }

        private void buttonTransferText4_Click(object sender, EventArgs e)
        {
            string TXString = "@P" + maskedTextBox4.Text.PadRight(20, ' ');
            textBoxTXData.Text = TXString;
            textBoxTxCRC.Text = CRC16(TXString).ToString("X4");
            TXString = TXString + textBoxTxCRC.Text;
            try
            {
                if (serialPort1.IsOpen == false) serialPort1.Open();
                serialPort1.WriteLine(TXString + "\r");
                System.Threading.Thread.Sleep(200);
                AnalyseRXString(serialPort1.ReadExisting());
                serialPort1.Close();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

        }

        private void buttonBaudRateSlaveEinstellen_Click(object sender, EventArgs e)
        {
            listBoxBaudrateSlave.Visible = true;
            
        }

        private void listBoxBaudrateSlave_SelectedIndexChanged(object sender, EventArgs e)
        {
            DialogResult result = MessageBox.Show("Die Baudrate auf " + listBoxBaudrateSlave.SelectedItem.ToString() + " umstellen?", "Baudrate umstellen", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
            if (result == DialogResult.Yes)
            {
                string TxString = "@$" + (listBoxBaudrateSlave.SelectedIndex + 1).ToString();
                textBoxTXData.Text = TxString;
                textBoxTxCRC.Text = CRC16(TxString).ToString("X4");
                TxString = TxString + textBoxTxCRC.Text;
                try
                {
                    if (serialPort1.IsOpen == false) serialPort1.Open();
                    serialPort1.WriteLine(TxString + "\r");
                    System.Threading.Thread.Sleep(100);
                    textBoxRXData.Text = serialPort1.ReadExisting();
                    serialPort1.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }


            }
            listBoxBaudrateSlave.Visible = false;
        }

        private void uARTToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }




      }
}
